#include <Servo.h>
//تعریف ثابت های پروژه
const int triggerPin = 7;
const int echoPin = 6;
const int BUZZER_PIN = 5;
const int LED_PIN_1 = 1;
const int LED_PIN_2 = 2;
const int LED_PIN_3 = 3;
const int MotorA_1 = 9;
const int MotorA_2 = 10;
const int MotorB_1 = 12;
const int MotorB_2 = 13;

int distanceCM;
Servo servo_1;
void setup() {
  pinMode(triggerPin,OUTPUT);
  pinMode(echoPin,INPUT);
  pinMode(BUZZER_PIN, OUTPUT);
  pinMode(LED_PIN_1,OUTPUT);
  pinMode(LED_PIN_2,OUTPUT);
  pinMode(LED_PIN_3,OUTPUT);
  pinMode(MotorA_1,OUTPUT);
  pinMode(MotorA_2,OUTPUT);
  pinMode(MotorB_1,OUTPUT);
  pinMode(MotorB_2,OUTPUT);
  servo_1.attach(4);
  digitalWrite(LED_PIN_1,HIGH);
  digitalWrite(LED_PIN_2,HIGH);
  digitalWrite(LED_PIN_3,HIGH);
  digitalWrite(BUZZER_PIN,HIGH);
  delay(2000);
  digitalWrite(LED_PIN_1,LOW);
  digitalWrite(LED_PIN_2,LOW);
  digitalWrite(LED_PIN_3,LOW);
  digitalWrite(BUZZER_PIN,LOW);
}
  long readUltrasonicDistance(int triggerPin, int echoPin)
{
  pinMode(triggerPin, OUTPUT); 
  digitalWrite(triggerPin, LOW);
  delayMicroseconds(6);
  digitalWrite(triggerPin, HIGH);
  delayMicroseconds(20);
  digitalWrite(triggerPin, LOW);
  pinMode(echoPin, INPUT);
  return pulseIn(echoPin, HIGH);
}

long CheckDistance(){
   distanceCM = 0.01723 * readUltrasonicDistance(7, 6);
   if(distanceCM>35){
    return true;
   }else{
    return false;
   }
}

void turnLeft(){
  digitalWrite(LED_PIN_2,LOW);
   digitalWrite(LED_PIN_1,HIGH);
   digitalWrite(MotorA_1,HIGH);
   digitalWrite(MotorA_2,LOW);
    digitalWrite(MotorB_1,LOW);
   digitalWrite(MotorB_2,LOW);
   delay(1000);
}

void turnRight(){
   digitalWrite(LED_PIN_2,HIGH);
   digitalWrite(LED_PIN_1,LOW);
   digitalWrite(MotorB_1,LOW);
   digitalWrite(MotorB_2,HIGH);
   digitalWrite(MotorA_1,LOW);
   digitalWrite(MotorA_2,LOW);
   delay(1000);
}

void stopMotors(){
   digitalWrite(LED_PIN_1,LOW);
   digitalWrite(LED_PIN_2,LOW);
   digitalWrite(LED_PIN_3,LOW);
   digitalWrite(BUZZER_PIN,LOW);
     digitalWrite(MotorB_1,LOW);
   digitalWrite(MotorB_2,LOW);
   digitalWrite(MotorA_1,LOW);
   digitalWrite(MotorA_2,LOW);
   delay(1000);
}

void go_straight(){
  servo_1.write(90);
   delay(1000);
   digitalWrite(LED_PIN_1,HIGH);
    digitalWrite(LED_PIN_2,HIGH);
    digitalWrite(LED_PIN_3,LOW);
    digitalWrite(BUZZER_PIN,LOW);
    digitalWrite(MotorA_1,HIGH);
    digitalWrite(MotorA_2,LOW);
    digitalWrite(MotorB_2,HIGH);
    digitalWrite(MotorB_1,LOW);
}

long go_backward(){
  digitalWrite(LED_PIN_1,LOW);
    digitalWrite(LED_PIN_2,LOW);
    digitalWrite(LED_PIN_3,HIGH);
    digitalWrite(BUZZER_PIN,HIGH);
    digitalWrite(MotorA_1,LOW);
    digitalWrite(MotorA_2,HIGH);
    digitalWrite(MotorB_2,LOW);
    digitalWrite(MotorB_1,HIGH);
      delay(500);
}

void loop() {
  if(CheckDistance()==true){
   go_straight();
  }else{
   stopMotors();
   delay(1000);
   go_backward();
   delay(300);
   stopMotors();
   servo_1.write(30);
    delay(20);
   distanceCM = 0.01723 * readUltrasonicDistance(7, 6);
   delay(500);
   if(distanceCM>35){
   turnRight();
   delay(500);
   }else{
   servo_1.write(150);
   distanceCM = 0.01723 * readUltrasonicDistance(7, 6);
   delay(500);
   if(distanceCM>35){
   turnLeft();
   delay(1000);
   }else{
    go_backward();
   delay(300);
   }
   }
  }
}
